<?php
include_spip('inc/presentation');
function exec_egt_conf(){
global $connect_statut, $connect_toutes_rubriques;
debut_page(_T('egt'), "", "");
echo "<br /><br />";
gros_titre(_T('Squelette egt'));

//
// Ce code permet la creation du groupe de mot cles egt_squelette et les 14 mots qui lui sont lies
// Avec l'aimable autorisation de l'auteur :
// Configurateur Squelette Epona - 2006 Fev 28 - Marc Lebas - http://spip-epona.org/
// 
//

function avertir($msg) {echo "<font color=orange>$msg</font><br>";}

function marque_erreur($msg) {
  global $erreur;
  echo "<b><font color=red>$msg</font></b><br>";
  $erreur = 1;
}



function rubrique_vide($id_rubrique) {
	$query = "SELECT id_rubrique FROM spip_rubriques WHERE id_parent='$id_rubrique' LIMIT 0,1";
	list($n) = spip_fetch_array(spip_query($query));
	if ($n > 0) return false;
	$query = "SELECT id_article FROM spip_articles WHERE id_rubrique='$id_rubrique' AND (statut='publie' OR statut='prepa' OR statut='prop') LIMIT 0,1";
	list($n) = spip_fetch_array(spip_query($query));
	if ($n > 0) return false;
	$query = "SELECT id_breve FROM spip_breves WHERE id_rubrique='$id_rubrique' AND (statut='publie' OR statut='prop') LIMIT 0,1";
	list($n) = spip_fetch_array(spip_query($query));
	if ($n > 0) return false;
	$query = "SELECT id_syndic FROM spip_syndic WHERE id_rubrique='$id_rubrique' AND (statut='publie' OR statut='prop') LIMIT 0,1";
	list($n) = spip_fetch_array(spip_query($query));
	if ($n > 0) return false;
	$query = "SELECT id_document FROM spip_documents_rubriques WHERE id_rubrique='$id_rubrique' LIMIT 0,1";
	list($n) = spip_fetch_array(spip_query($query));
	if ($n > 0) return false;
	return true;
}



//
// Fonctions pour mot-cles
//
function groupe_vide($titre) {
  if (id_groupe($titre) != 0) {
       marque_erreur("Le groupe $titre existe d&eacute;j&agrave;");
       return FALSE;
  }
  return TRUE;
}

function id_groupe($titre) {
  // leve une erreur si plusieurs
  $result = spip_query("SELECT id_groupe FROM spip_groupes_mots WHERE titre='$titre'");
  switch (spip_num_rows($result)) {
    case 0 : return 0;
    case 1 : while ($row = spip_fetch_array($result)) return $row['id_groupe'];
    default : 
      marque_erreur(spip_num_rows($result)." groupes $titre : ");
      while ($row = spip_fetch_array($result)) echo 'id_groupe= '.$row['id_groupe'].'<br>';
      return -1;
  }
}

function id_mot($titre, $type) {
  // leve une erreur si plusieurs
  $result = spip_query("SELECT id_mot, titre FROM spip_mots WHERE titre='$titre' AND type='$type'");
  switch (spip_num_rows($result)) {
    case 0 : return 0;
    case 1 : while ($row = spip_fetch_array($result)) return $row['id_mot'];
    default : 
      marque_erreur(spip_num_rows($result)." mots $titre pour groupe mot $type :");
      while ($row = spip_fetch_array($result)) echo 'id_mot= '.$row['id_mot'].' '.$row['titre'].'<br>';
      return -1;
  }
}

function active_groupe($groupe, $mots) {
  $id_groupe=id_groupe($groupe);
  if ($id_groupe != 0) return FALSE;
  //Creation groupe + mot-cles
  if (!spip_query("INSERT INTO spip_groupes_mots SET titre='$groupe', unseul='non', obligatoire='non',
                 articles='oui', breves='non', rubriques='oui', syndic='oui',
                  minirezo='oui', comite='non', forum='non'")) {
     marque_erreur("Erreur cr&eacute;ation $groupe");
     return FALSE;
  }
  $id_groupe = spip_insert_id();
  foreach ($mots as $mot) {
    if (!spip_query("INSERT INTO spip_mots (type, titre, id_groupe) VALUES ('$groupe', '$mot', '$id_groupe')")) {
       marque_erreur("Erreur cr&eacute;ation mot $mot dans groupe $groupe");
       return FALSE;
    }
    echo " $mot";
  }
  echo " (groupe mots $groupe cr&eacute;&eacute;)<br>";
  return TRUE;
}

function active_groupe_rub($groupe, $mots) {
  $id_groupe=id_groupe($groupe);
  if ($id_groupe != 0) return FALSE;
  //Creation groupe + mot-cles
  if (!spip_query("INSERT INTO spip_groupes_mots SET titre='$groupe', unseul='non', obligatoire='non',
                 articles='non', breves='non', rubriques='oui', syndic='oui',
                  minirezo='oui', comite='non', forum='non'")) {
     marque_erreur("Erreur cr&eacute;ation $groupe");
     return FALSE;
  }
  $id_groupe = spip_insert_id();
  foreach ($mots as $mot) {
    if (!spip_query("INSERT INTO spip_mots (type, titre, id_groupe) VALUES ('$groupe', '$mot', '$id_groupe')")) {
       marque_erreur("Erreur cr&eacute;ation mot $mot dans groupe $groupe");
       return FALSE;
    }
    echo " $mot";
  }
  echo " (groupe mots $groupe cr&eacute;&eacute;)<br>";
  return TRUE;
}

function pre_desactive_groupe($titre) {
  // seulement pour verifier que le groupe est libre
  $rcode = TRUE;
  $id_groupe=id_groupe($titre);
  if ($id_groupe == 0) return TRUE;
  if ($id_groupe == -1) return FALSE;
  $result = spip_query("SELECT id_mot, titre FROM spip_mots WHERE id_groupe=$id_groupe");
  while ($row = spip_fetch_array($result)) {
    if (!pre_desactive_mot($row['id_mot'], $row['titre'])) $rcode = FALSE;
  }
  return $rcode;
}

function desactive_groupe($titre) {
  // aucun contrle d'attachement; deja fait par pre_desactive_groupe
  $id_groupe=id_groupe($titre);
  if ($id_groupe == 0) return TRUE;
  if ($id_groupe == -1) return FALSE;
  $result = spip_query("SELECT id_mot, titre FROM spip_mots WHERE id_groupe=$id_groupe");
  while ($row = spip_fetch_array($result)) {
    spip_query("DELETE FROM spip_mots WHERE id_mot='".$row['id_mot']."'");
    foreach (array('breves', 'articles', 'rubriques', 'forum', 'syndic') as $elem)
      spip_query("DELETE FROM spip_mots_".$elem." WHERE id_mot=".$row['id_mot']);
    spip_query("DELETE FROM spip_index_mots WHERE id_mot=".$row['id_mot']);
    echo $row['titre'].' ';
  }
  spip_query("DELETE FROM spip_groupes_mots WHERE id_groupe='$id_groupe'");
  echo " (groupe mots $titre effac&eacute;)<br>";
  return TRUE;
}

function pre_desactive_mot($id_mot, $titre) {
  // pour verifier qu'un mot est libre
  $rcode = TRUE;
  foreach (array('breve', 'article', 'rubrique') as $elem) {
    $result = spip_query("SELECT id_".$elem." FROM spip_mots_".$elem."s WHERE id_mot=$id_mot");
    if ($row = spip_fetch_array($result)) {
      avertir("Le mot-cl&eacute; $titre est attach&eacute; ($elem)");
      $rcode = FALSE;
    }
  }
  foreach (array('forum', 'syndic') as $elem) {
    $result = spip_query("SELECT id_".$elem." FROM spip_mots_".$elem." WHERE id_mot=$id_mot");
    if ($row = spip_fetch_array($result)) {
      avertir("Le mot-cl&eacute; $titre est attach&eacute; ($elem)");
      $rcode = FALSE;
    }
  }
  return $rcode;
}


debut_cadre_relief(  "", false, "", $titre = _T('Configuration'));
        debut_boite_info();
        echo '<br>';




function mots_on() {
  echo "<h1>Cr&eacute;ation mot-cl&eacute;s</h1>";
  if (id_groupe('egt_squelette') == 0) {
    active_groupe('egt_squelette', array('afficher aide site', 'afficher article actu','afficher article dans colonne centrale','afficher infos bandeau','afficher logo breves','afficher logo participer','afficher logo rechercher','afficher nom site','afficher site syndique et articles','afficher texte a retenir','afficher titre a retenir','exclure de dernieres parutions','exclure du menu','ne pas afficher formulaire site',));
  } else avertir("Le groupe egt_squelette existe d&eacute;j&agrave;");
}

function mots_off() {
  echo "<h1>Suppression mot-cl&eacute;s</h1>";
  foreach (array('egt_squelette') as $titre) {
    if (!pre_desactive_groupe($titre)) {
      avertir("Groupe $titre encore attach&eacute;");
    } else desactive_groupe($titre);
  }
}



//
// Main - Point d'entree du programme
//
function exec_egt_conf1 () {
}

global $type_agenda;
if (!file_exists("inc_version.php")) {
  marque_erreur("inc_version.php non trouv&eacute;. Suis-je bien dans le r&eacute;pertoire ecrire de Spip ?");
  exit;
}
if (!defined('_ECRIRE_INC_VERSION')) include ("inc_version.php");
include_ecrire('inc_cookie');
if ($GLOBALS['connect_statut'] != "0minirezo") {
  marque_erreur("Acc&eagrave;s refus&eacute;");
  exit;
}
if (file_exists(_FILE_OPTIONS)) include(_FILE_OPTIONS);

//
// Affichage et arret si la base n'est pas coherente
//
foreach (array('egt_squelette') as $titre) id_groupe($titre);
foreach (array('afficher aide site', 'afficher article actu','afficher article dans colonne centrale','afficher infos bandeau','afficher logo breves','afficher logo participer','afficher logo rechercher','afficher nom site','afficher site syndique et articles','afficher texte a retenir','afficher titre a retenir','exclure de dernieres parutions','exclure du menu','ne pas afficher formulaire site',) as $titre) id_mot($titre, 'egt_squelette');



echo "<h4>Cette page permet de cr&eacute;er <br> en un clic le groupe de mots cl&eacute;s <br>
egt_squelette et tous les mots cl&eacute;s qui lui <br>sont li&eacute;s,  ils sont n&eacute;cessaires &agrave; la personnalisation <br> du site.</h4>";

//
// Affichage etat final
//

echo '<h1>Etat</h1>';

foreach (array('egt_squelette') as $titre) {
  $id_groupe=id_groupe($titre);
  if ($id_groupe == 0) {echo  "Groupe ".$titre." : absent<br>";} else {
    echo  "Groupe ".$titre." : pr&eacute;sent<br>";
    pre_desactive_groupe($titre);
  }
}


// Analyse et traitement requete
//

switch ($GLOBALS['action']) {
  case 'mots_on' : mots_on($type_agenda); break;
  case 'mots_off' : mots_off($type_agenda); break;
}
if (isset($erreur)) marque_erreur("<h1>Echec</h1>");
//
// Affichage menu
//


echo "<h1>Cr&eacute;er les mots cl&eacute;s</h1>";


echo "<a href=\"?exec=egt_conf&action=mots_on\">Cliquer sur ce lien pour cr&eacute;er le groupe de<br> mots cl&eacute;s <b>egt_squelette</b> et les mots cl&eacute;s<br> qui lui sont li&eacute;s (14) puis actualisez la page</a>";
 
echo '<h2>Remerciements</h2>
Merci &agrave; Marc pour ce script (squelette <a href="http://spip-epona.org/">Epona</a>)<br>
ainsi que <a href="http://www.plugandspip.com"> Les plugins Spip</a> pour leurs tutoriels';

        fin_boite_info();
 fin_cadre_relief();
fin_page();
                        exit;
                }
?>
